window.onmousedown = iaOnMouseDown;
var imageSrc;

/**
 * For right clicks on images stores src, as well as shows and enables menu item. 
 * If a right clicks is on a non-image, hides and disables the menu item.
 * @param	e	mouse event
 */	
function iaOnMouseDown(e) {
	if (e.which == 3) 
	{
		var target = e.target;
		var classname = e.target.toString();
		if (classname.match(/ImageElement/)) {
			// Simpler, but probably less efficient syntax: target.src;
			var hie = target.QueryInterface(Components.interfaces.nsIDOMHTMLImageElement);
			if (hie != null)
				// show menu item:
				setImageSource(hie);
			else
				setImageSource(null);
		} else
				setImageSource(null);
	}
}

/**
 * Utility function keeping <tt>imageSrc</tt> and menu item state in synch.
 * @param	src	image element or null
 */
function setImageSource(imageElement) {
	if (imageElement != null)
		imageSrc = imageElement.src;
	else
		imageSrc = null;
	var launchImage = document.getElementById('imageassistant-context-launch-image');
	launchImage.setAttribute("hidden", imageSrc == null ? "true" : "false");
	var disabled = imageSrc == null || !imageElement.complete;
	launchImage.setAttribute("disabled", disabled ? "true" : "false");
	var sb = document.getElementById("imageassistant-bundle");
	var qiymet = null;
	if (disabled)
		qiymet = sb.getString("image-still-being-downloaded");
	else
		qiymet = sb.getString("launchImageCmd-label");
	if (launchImage.getAttribute("label") != qiymet)
		launchImage.setAttribute("label", qiymet);
}

/**
 * Invokes component method.
 */
function launchImage() {
	// Call back-end
	var obj = Components.classes["@ultranet.tv/ImageAssistant/ImageLauncher;1"].createInstance();
	obj = obj.QueryInterface(Components.interfaces.IImageLauncher);
	try {
		var result = obj.Launch(imageSrc);
		if (result != 0) {
			var sb = document.getElementById("imageassistant-bundle");
			alert(sb.getString("failed-to-open-image") + result + sb.getString("."));
		}
	} catch (e) {
		var sb = document.getElementById("imageassistant-bundle");
		alert(sb.getString("ia-caught-exception")+ " " +sb.getString("result") + e.result + sb.getString(".") + sb.getString("message") + e.message + sb.getString("."));
	}
}